;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATtiny26
;Clock frequency     : 8,000000 MHz
;Memory model        : Tiny
;Optimize for        : Speed
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 32 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Stay_On_Line.vec"
	.INCLUDE "Stay_On_Line.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 /*************************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot suiveur de ligne "Carte MrLineTiny"
;      10 Version : 2
;      11 Date    : 24/11/2007
;      12 Author  : Philippe Mariano                
;      13 Company : LYCEE Pierre Emile MARTIN       
;      14 Comments: Suivi de ligne (fichier lve)
;      15 
;      16 Fichier : Stay_On_Line_V2.c      
;      17 
;      18 Chip type           : ATtiny26(L)
;      19 Clock frequency     : 16,000000 MHz
;      20 Memory model        : Tiny
;      21 External SRAM size  : 0
;      22 Data Stack size     : 32
;      23 *************************************************************/
;      24 
;      25 #include <tiny26.h>
;      26 #include <delay.h>
;      27 
;      28 // Boolen
;      29 //-----------------------------------------------------------------
;      30 #define ACO 	ACSR.5      	// Sortie du comparateur analogique   
;      31 
;      32 // Temporisations
;      33 //--------------------------------------------------------------------------------------------------
;      34 #define t_IR 	19 		// Dure de la commande d'un E_IR (Del IR)
;      35 #define t_mux 	540    		// Dure entre deux cde d'un E_IR
;      36 #define t_delay 704     	// Permet de rgler la priode d'chantillonnage (tech) de la position
;      37 		       		// du robot par rapport  la ligne tech = 3*(t_IR + t_mux) + t_delay
;      38 			
;      39 // Commande des moteurs  
;      40 //------------------------------------------------------
;      41 #define CDE_ROUE_D	OCR1A       //  de la roue droite
;      42 #define CDE_ROUE_G	OCR1B	    //  de la roue gauche
;      43 
;      44 // Valeurs reprsentatives du rapport cyclique du signal 
;      45 // de commande des moteurs
;      46 //------------------------------------------------------  
;      47 #define _0PC	 255		 // 0%  
;      48 #define _10PC	 25              // 10%
;      49 #define _20PC    51		 // 20%
;      50 #define _30PC    76		 // 30% 
;      51 #define _40PC    102		 // 40%
;      52 #define _50PC    128             // 50% 
;      53 #define _60PC    153             // 60%
;      54 #define _70PC    179             // 70%
;      55 #define _80PC    205             // 80%     
;      56 
;      57 // Connexions des Dels Visu et IR au port A  
;      58 //-------------------------------------------------------------------------------------     						 
;      59 // Del_G	relie  PA3 (D2)     E_G_IR	PAO  (DIR3)
;      60 // Del_D 	relie  PA4 (D1)     E_C_IR	PA1  (DIR2)
;      61 // Del_C	relie  PA5 (D3)     E_D_IR	PA2  (DIR1)
;      62 
;      63 // Mots de commande des Dels Visu 
;      64                   				// Etat des Dels de visualisation
;      65              					// Del_G | Del_C | Del_D      Position     	Remarque
;      66 #define Visu_Hors_ligne         0b00111111      // off   | off   | off            0		- - -
;      67 #define Visu_Droite_Plus        0b00110111      // off   | off   | on             1		* - -
;      68 #define Visu_Centre1		0b00011111      // off   | on    | off            2		- * -
;      69 #define Visu_Droite		0b00010111      // off   | on    | on             3             * * -
;      70 #define Visu_Gauche_Plus        0b00101111      // on    | off   | off 	          4             - - *
;      71 #define Visu_Centre2            0b00100111      // on    | off   | on             5             * - *
;      72 #define Visu_Gauche             0b00001111      // on    | on    | off            6             - * *
;      73 #define Visu_Centre3            0b00000111      // on    | on    | on             7		* * *
;      74   
;      75 // Prototype des fonctions
;      76 //---------------------------
;      77 void Arret_Moteurs();
;      78 void Active_Timer();
;      79 
;      80 // Variables globales 
;      81 // type		nom		Commentaires
;      82 //--------------------------------------------------
;      83 // Les diffrentes commandes des moteurs
;      84 enum Etat_Commande_Moteur {DEPART,CDE_CENTRE1, CDE_CENTRE2, CDE_CENTRE3, 
;      85 CDE_DROITE, CDE_DROITE_PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS} EtatCdeMot = DEPART;
;      86 
;      87 // Les diffrentes positions du robot par rapport  la ligne 
;      88 enum Etat_Position_Robot {HORS_LIGNE, DROITE_PLUS, CENTRE_1, DROITE, 
;      89 GAUCHE_PLUS, CENTRE_2, GAUCHE, CENTRE_3} Position_Robot = HORS_LIGNE; 
;      90 
;      91 
;      92 ///-----------------------------
;      93 // Dbut du programme principal
;      94 //------------------------------
;      95 void main(void)
;      96 {

	.CSEG
_main:
;      97 
;      98 // Variables locales
;      99 // type		nom		Commentaires
;     100 //---------------------------------------------------------------------------
;     101 unsigned char i;                // Compteur de boucles
;     102 unsigned char Cde_Del_IR;	// Permet de multiplexer la commande des dels IR
;     103 unsigned char VisuPosition;	// Affichage de la position du robot sur 3 dels
;     104 
;     105 // Input/Output Ports initialization
;     106 // Port A initialization
;     107 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=In Func7=In 
;     108 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=T State7=T 
;     109 PORTA=0x3F;
;	i -> R16
;	Cde_Del_IR -> R17
;	VisuPosition -> R18
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     110 DDRA=0x3F;
	OUT  0x1A,R30
;     111 
;     112 // Port B initialization
;     113 // Func0=In Func1=Out Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In 
;     114 // State0=T State1=1 State2=T State3=1 State4=T State5=T State6=P State7=T 
;     115 PORTB=0x0A;
	LDI  R30,LOW(10)
	OUT  0x18,R30
;     116 DDRB=0x0A;
	OUT  0x17,R30
;     117 
;     118 // Timer/Counter 1 initialization
;     119 // Clock source: System Clock
;     120 // Clock value: 4000,000 kHz
;     121 // Mode: PWMA & B top=OCR1C
;     122 // OC1A output: Inverted, /OC1A disconnected
;     123 // OC1B output: Inverted, /OC1B disconnected
;     124 PLLCSR=0x00;
	CLR  R30
	OUT  0x29,R30
;     125 TCCR1A=0xF3;
	LDI  R30,LOW(243)
	OUT  0x30,R30
;     126 TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2F,R30
;     127 TCNT1=0x00;
	CLR  R30
	OUT  0x2E,R30
;     128 OCR1A=0x00;
	OUT  0x2D,R30
;     129 OCR1B=0x00;
	OUT  0x2C,R30
;     130 OCR1C=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2B,R30
;     131 
;     132 // Analog Comparator initialization
;     133 // Analog Comparator: On
;     134 ACSR=0x00;
	CLR  R30
	OUT  0x8,R30
;     135      
;     136 PORTA = 0x3F;   // Extinction des Dels
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     137 
;     138 while (1)
_0x6:
;     139     {// dbut while
;     140       Position_Robot = 0;   // Initialisation	
	CLR  R5
;     141       Cde_Del_IR = 1; 
	LDI  R17,LOW(1)
;     142     
;     143 /* --------------------------------------------------------------------------------------------------------------------
;     144 Dbut de la tche "Acqurir la position du robot par rapport  la ligne" (Intgre dans FS21 et FS35)
;     145 -----------------------------------------------------------------------------------------------------------------------
;     146 FS21 " Commander un des trois metteurs IR(Del)"
;     147 
;     148 Rle : Slectionner un des trois metteurs (Del IR) devant gnrer un faisceau IR
;     149        
;     150 Entre : 	Cde_Del_IR 		octet permettant de multiplexer la commande des dels IR     
;     151 
;     152 Sorties:        PA0, PA1, PA2 		bits de commande des dels IR (dtails ci-dessous)
;     153 					Emmetteur IR connect  au bit      Remarque 
;     154 					----------------------------------------------------         
;     155 					E_D_IR		"      PA2    |   Emmeteur IR droit       
;     156 					E_C_IR		"      PA1    |	  Emmeteur IR centre      
;     157 					E_G_IR 		"      PA0    |	  Emmeteur IR gauche     
;     158 -------------------------------------------------------------------------------------------------------------------------                                                                                        
;     159 FS35 "Calculer la position du robot par rapport  la ligne"   
;     160 
;     161 Rle : Etablir une valeur numrique reprsentative de la position du robot par rapport  la ligne
;     162  
;     163 Entres : 	AC0		 	bit associ  la sortie du comparateur analogique, 
;     164 					reprsentatif de la position d'un capteur sur la ligne 
;     165 					
;     166 Sortie :	Position_Robot		octet image de la position du robot par rapport  la ligne)
;     167                                         (dtails ci-dessous)
;     168                                         
;     169 Position des capteurs IR  =>  "Position_Robot"	// Positions du robot par rapport  la ligne
;     170 --------------------------------------------------------------------------------------------
;     171 IR_D  | IR_C  |  IR_G    =>     Position_Robot
;     172 non  |  non  |   non     =>	   0		// Hors ligne
;     173 non  |  non  |   oui     =>	   1         	// Droite+
;     174 non  |  oui  |   non     =>	   2         	// Centre1 (ligne noire de largeur gale  celle d'un capteur)
;     175 non  |  oui  |   oui     =>	   3         	// Droite
;     176 oui  |  non  |   non     =>	   4		// Gauche+
;     177 oui  |  non  |   oui     =>	   5         	// Centre2 (ligne blanche entoure de deux noires)
;     178 oui  |  oui  |   non     =>	   6		// Gauche
;     179 oui  |  oui  |   oui     =>	   7         	// Centre3 (ligne noire de largeur gale  celle de trois capteurs)
;     180     			     	
;     181 -------------------------------------------------------------------------------------------------------------------------*/
;     182 
;     183       for (i=0;i<3;i++)  
	LDI  R16,LOW(0)
_0xA:
	CPI  R16,3
	BRSH _0xB
;     184        {
;     185         PORTA = ~Cde_Del_IR; 					      // Les E_IR (Leds IR) sont commands  l'tat bas
	MOV  R30,R17
	COM  R30
	OUT  0x1B,R30
;     186       	delay_us(t_IR);						      // Dure de l'tat bas (A ajuster en fonction des capteurs) 
	__DELAY_USB 51
;     187         if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;   // Si le capteur IR_x x=(D,C,G] est sur la ligne
	SBIS 0x8,5
	RJMP _0xC
	OR   R5,R17
;     188         PORTA = 0x3F;                                                 // le bit correspondant de "Position_Robot est mis  1 
_0xC:
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     189         Cde_Del_IR = Cde_Del_IR << 1 ;                                 
	LSL  R17
;     190         delay_us(t_mux);					      // Tempo permettant d'attendre l'anulation de la ddp sur
	__DELAY_USW 1080
;     191         							      // l'entre AIN1 (signal de rception IR) avant une nouvelle 
;     192         							      // mesure (A ajuster en fonction des capteurs)
;     193        }   
	SUBI R16,-1
	RJMP _0xA
_0xB:
;     194        
;     195 /* Fin de la tche "Acqurir la position du robot par rapport  la ligne" (Fonctions FS21 et FS35) 
;     196 --------------------------------------------------------------------------------------------------------------------------*/
;     197          
;     198 
;     199 /* ------------------------------------------------------------------------------------------------------------------------                
;     200 Dbut de la tche  "Traiter l'information "Position_Robot" pour visualiser la position du robot par rapport  la ligne" (Fonction FP1) 
;     201 ---------------------------------------------------------------------------------------------------------------------------
;     202 Rle :  lorsque le capteur est sur la ligne, la Del correspondante s'claire
;     203 
;     204 Entre:         Position_Robot      	(voir ci-dessus)
;     205 
;     206 Sorties:	PortA            	octet
;     207  					Del de visualisation connecte au bit
;     208 					----------------------------------------
;     209 					Del_D       "      		PA4      
;     210 					Del_C       "	  		PA5
;     211 					Del_G       "	  		PA3 
;     212 					Remarque : D pour droite, C pour centre, G pour gauche
;     213 ---------------------------------------------------------------------------------------------------------------------------*/
;     214     			
;     215       switch (Position_Robot)              	       		// Etat des Dels de visualisation     	
	MOV  R30,R5
;     216        {                                   	       		// Del_G | Del_C | Del_D 	
;     217         case 0: VisuPosition = Visu_Hors_ligne; break; 		// off   | off   | off 	
	CPI  R30,0
	BRNE _0x10
	LDI  R18,LOW(63)
	RJMP _0xF
;     218         case 1: VisuPosition = Visu_Droite_Plus; break; 	// off   | off   | on 	
_0x10:
	CPI  R30,LOW(0x1)
	BRNE _0x11
	LDI  R18,LOW(55)
	RJMP _0xF
;     219         case 2: VisuPosition = Visu_Centre1; break; 		// off   | on    | off 	
_0x11:
	CPI  R30,LOW(0x2)
	BRNE _0x12
	LDI  R18,LOW(31)
	RJMP _0xF
;     220         case 3: VisuPosition = Visu_Droite; break;     		// off   | on    | on 	
_0x12:
	CPI  R30,LOW(0x3)
	BRNE _0x13
	LDI  R18,LOW(23)
	RJMP _0xF
;     221         case 4: VisuPosition = Visu_Gauche_Plus; break; 	// on    | off   | off  		
_0x13:
	CPI  R30,LOW(0x4)
	BRNE _0x14
	LDI  R18,LOW(47)
	RJMP _0xF
;     222         case 5: VisuPosition = Visu_Centre2; break; 		// on    | off   | on 	
_0x14:
	CPI  R30,LOW(0x5)
	BRNE _0x15
	LDI  R18,LOW(39)
	RJMP _0xF
;     223         case 6: VisuPosition = Visu_Gauche; break; 		// on    | on    | off  	
_0x15:
	CPI  R30,LOW(0x6)
	BRNE _0x16
	LDI  R18,LOW(15)
	RJMP _0xF
;     224         case 7: VisuPosition = Visu_Centre3; break;      	// on    | on    | on  	
_0x16:
	CPI  R30,LOW(0x7)
	BRNE _0xF
	LDI  R18,LOW(7)
;     225        }   
_0xF:
;     226          
;     227 // Fin de la tche  "Traiter l'information "Position_Robot" pour visualiser la position du robot par rapport  la ligne" (Fonction FP1)
;     228 // ----------------------------------------------------------------------------------------------------------------------------------
;     229          
;     230 
;     231        PORTA = VisuPosition;  // Fonction FS61 "Slectionner les dels de visualisation"      
	OUT  0x1B,R18
;     232 
;     233 /* ------------------------------------------------------------------------------------------------------------- 
;     234 Dbut de la tche  "Traiter l'information "Position_Robot" pour corriger la trajectoire du robot" (Fonction FP1) 
;     235 ----------------------------------------------------------------------------------------------------------------
;     236 Rle: Rgler le rapport cyclique des signaux de commande des moteurs droit et gauche pour rgler la trajectoire 
;     237 du robot afin qu'il suive la ligne
;     238 
;     239 Entre:          Position_Robot                  		(voir ci-dessus)    
;     240 
;     241 Sorties:         CDE_ROUE_G                 octet		(OCR1A)rgle le rapport cyclique 
;     242 								du signal de commande du moteur Gauche
;     243 		 CDE_ROUE_D                                     (OCR1B)rgle le rapport cyclique 
;     244 								du signal de commande du moteur Droit
;     245 ---------------------------------------------------------------------------------------------------------------*/      
;     246       switch (EtatCdeMot)              
	MOV  R30,R4
;     247        { // Dbut switch (EtatCdeMot)                                 
;     248         case DEPART: Arret_Moteurs(); 
	CPI  R30,0
	BRNE _0x1B
	RCALL _Arret_Moteurs
;     249         		if ((Position_Robot == CENTRE_1) || (Position_Robot == CENTRE_2) || (Position_Robot == CENTRE_3))
	LDI  R30,LOW(2)
	CP   R30,R5
	BREQ _0x1D
	LDI  R30,LOW(5)
	CP   R30,R5
	BREQ _0x1D
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0x1C
_0x1D:
;     250         		    { 
;     251         		      delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     252         		      Active_Timer();
	RCALL _Active_Timer
;     253         		      EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     254         		    }
;     255         		    else  EtatCdeMot = DEPART;
	RJMP _0x1F
_0x1C:
	CLR  R4
_0x1F:
;     256         break;   
	RJMP _0x1A
;     257         
;     258         case CDE_CENTRE1: CDE_ROUE_G = _40PC; CDE_ROUE_D = _40PC;
_0x1B:
	CPI  R30,LOW(0x1)
	BRNE _0x20
	LDI  R30,LOW(102)
	OUT  0x2C,R30
	OUT  0x2D,R30
;     259                           if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x21
	LDI  R30,LOW(4)
	MOV  R4,R30
;     260                           	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RJMP _0x22
_0x21:
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x23
	LDI  R30,LOW(6)
	RJMP _0x3F
;     261                           		else EtatCdeMot = CDE_CENTRE1;
_0x23:
	LDI  R30,LOW(1)
_0x3F:
	MOV  R4,R30
_0x22:
;     262         break;  
	RJMP _0x1A
;     263         
;     264         case CDE_CENTRE2: EtatCdeMot = CDE_CENTRE1;   
_0x20:
	CPI  R30,LOW(0x2)
	BRNE _0x25
	LDI  R30,LOW(1)
	MOV  R4,R30
;     265         
;     266         break;   
	RJMP _0x1A
;     267         
;     268         case CDE_CENTRE3: EtatCdeMot = CDE_CENTRE1;
_0x25:
	CPI  R30,LOW(0x3)
	BRNE _0x26
	LDI  R30,LOW(1)
	MOV  R4,R30
;     269         break; 
	RJMP _0x1A
;     270         
;     271         case CDE_DROITE:CDE_ROUE_G = _40PC; CDE_ROUE_D = _30PC; 
_0x26:
	CPI  R30,LOW(0x4)
	BRNE _0x27
	LDI  R30,LOW(102)
	OUT  0x2C,R30
	LDI  R30,LOW(76)
	OUT  0x2D,R30
;     272                          if (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x28
	LDI  R30,LOW(1)
	MOV  R4,R30
;     273                           	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
	RJMP _0x29
_0x28:
	LDI  R30,LOW(4)
	CP   R30,R5
	BRNE _0x2A
	LDI  R30,LOW(5)
	RJMP _0x40
;     274                           		else EtatCdeMot = CDE_DROITE;
_0x2A:
	LDI  R30,LOW(4)
_0x40:
	MOV  R4,R30
_0x29:
;     275         break;   
	RJMP _0x1A
;     276         
;     277         case CDE_DROITE_PLUS:CDE_ROUE_G = _50PC; CDE_ROUE_D = _30PC;
_0x27:
	CPI  R30,LOW(0x5)
	BRNE _0x2C
	LDI  R30,LOW(128)
	OUT  0x2C,R30
	LDI  R30,LOW(76)
	OUT  0x2D,R30
;     278         		if (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x2D
	LDI  R30,LOW(1)
	MOV  R4,R30
;     279                              else if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	RJMP _0x2E
_0x2D:
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x2F
	LDI  R30,LOW(4)
	RJMP _0x41
;     280                           		else EtatCdeMot = CDE_DROITE_PLUS;
_0x2F:
	LDI  R30,LOW(5)
_0x41:
	MOV  R4,R30
_0x2E:
;     281         break;  
	RJMP _0x1A
;     282         
;     283         case CDE_GAUCHE: CDE_ROUE_G = _30PC; CDE_ROUE_D = _40PC; 
_0x2C:
	CPI  R30,LOW(0x6)
	BRNE _0x31
	LDI  R30,LOW(76)
	OUT  0x2C,R30
	LDI  R30,LOW(102)
	OUT  0x2D,R30
;     284                        if (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x32
	LDI  R30,LOW(1)
	MOV  R4,R30
;     285                           	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
	RJMP _0x33
_0x32:
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x34
	LDI  R30,LOW(7)
	RJMP _0x42
;     286                           		else EtatCdeMot = CDE_GAUCHE;
_0x34:
	LDI  R30,LOW(6)
_0x42:
	MOV  R4,R30
_0x33:
;     287         break;  
	RJMP _0x1A
;     288         
;     289         case CDE_GAUCHE_PLUS: CDE_ROUE_G = _30PC; CDE_ROUE_D = _50PC; 
_0x31:
	CPI  R30,LOW(0x7)
	BRNE _0x3B
	LDI  R30,LOW(76)
	OUT  0x2C,R30
	LDI  R30,LOW(128)
	OUT  0x2D,R30
;     290                       if  (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x37
	LDI  R30,LOW(1)
	MOV  R4,R30
;     291         	              else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RJMP _0x38
_0x37:
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x39
	LDI  R30,LOW(6)
	RJMP _0x43
;     292                           		else EtatCdeMot = CDE_GAUCHE_PLUS;
_0x39:
	LDI  R30,LOW(7)
_0x43:
	MOV  R4,R30
_0x38:
;     293         break; 
	RJMP _0x1A
;     294         
;     295         default : EtatCdeMot = CDE_CENTRE1; break;
_0x3B:
	LDI  R30,LOW(1)
	MOV  R4,R30
;     296          
;     297        }// Fin switch (EtatCdeMot)
_0x1A:
;     298          
;     299 // Fin de la tche  "Traiter l'information "Position_Robot" pour corriger la trajectoire du robot" (Fonction FP1)       
;     300 // --------------------------------------------------------------------------------------------------------------  
;     301 
;     302 	delay_us(t_delay); // A ajuster en fonction de la vitesse du robot  
	__DELAY_USW 1408
;     303       		
;     304     }// fin while(1);
	RJMP _0x6
;     305 } // fin prog princ   
_0x3C:
	RJMP _0x3C
;     306 
;     307 
;     308 
;     309 // ---------------------------------
;     310 // Sous-programmes
;     311 // ---------------------------------
;     312 void Arret_Moteurs()
;     313 {
_Arret_Moteurs:
;     314       TCCR1A = 0x00; // Arrt PWM 
	CLR  R30
	OUT  0x30,R30
;     315       TCCR1B = 0x00; 
	OUT  0x2F,R30
;     316       PORTB=0x0B;     // Arrt Moteur 
	LDI  R30,LOW(11)
	OUT  0x18,R30
;     317 } 
	RET
;     318 
;     319 void Active_Timer()
;     320 {       // Marche PWM
_Active_Timer:
;     321       	TCCR1A=0xF3;
	LDI  R30,LOW(243)
	OUT  0x30,R30
;     322 	TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2F,R30
;     323 } 
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

